from .misc import is_iterable as is_iterable, xor as xor
from _typeshed import Incomplete
from typing import Optional, Union

class BitSequenceError(Exception): ...

class BitSequence:
    def __init__(
        self,
        value: Union["BitSequence", str, int] = ...,
        msb: bool = ...,
        length: int = ...,
        bytes_: Optional[bytes] = ...,
        msby: bool = ...,
    ) -> None: ...
    def sequence(self) -> bytearray: ...
    def reverse(self) -> BitSequence: ...
    def invert(self) -> BitSequence: ...
    def append(self, seq) -> BitSequence: ...
    def lsr(self, count: int) -> None: ...
    def rsr(self, count: int) -> None: ...
    def tobit(self) -> bool: ...
    def tobyte(self, msb: bool = ...) -> int: ...
    def tobytes(self, msb: bool = ..., msby: bool = ...) -> bytearray: ...
    def __iter__(self): ...
    def __reversed__(self): ...
    def __getitem__(self, index): ...
    def __setitem__(self, index, value) -> None: ...
    def __len__(self) -> int: ...
    def __eq__(self, other): ...
    def __ne__(self, other): ...
    def __le__(self, other): ...
    def __lt__(self, other): ...
    def __ge__(self, other): ...
    def __gt__(self, other): ...
    def __int__(self) -> int: ...
    def __and__(self, other): ...
    def __or__(self, other): ...
    def __add__(self, other): ...
    def __ilshift__(self, count): ...
    def __irshift__(self, count): ...
    def inc(self) -> None: ...
    def dec(self) -> None: ...
    def invariant(self) -> bool: ...

class BitZSequence(BitSequence):
    Z: int
    def __init__(
        self, value: Incomplete | None = ..., msb: bool = ..., length: int = ...
    ) -> None: ...
    def invert(self): ...
    def tobyte(self, msb: bool = ...) -> None: ...
    def tobytes(self, msb: bool = ..., msby: bool = ...) -> None: ...
    def matches(self, other): ...
    def __int__(self) -> int: ...
    def __cmp__(self, other): ...
    def __and__(self, other): ...
    def __or__(self, other): ...
    def __rand__(self, other): ...
    def __ror__(self, other): ...
    def __radd__(self, other): ...

class BitField:
    def __init__(self, value: int = ...) -> None: ...
    def to_seq(self, msb: int = ..., lsb: int = ...): ...
    def __getitem__(self, index): ...
    def __setitem__(self, index, value) -> None: ...
    def __int__(self) -> int: ...
